/*
  Copyright 2021 Kakao Corp.

  Licensed under the Apache License, Version 2.0 (the "License");
  you may not use this file except in compliance with the License.
  You may obtain a copy of the License at

     http://www.apache.org/licenses/LICENSE-2.0

  Unless required by applicable law or agreed to in writing, software
  distributed under the License is distributed on an "AS IS" BASIS,
  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
  See the License for the specific language governing permissions and
  limitations under the License.
 */
package com.kakao.sdk.partner.friend.client

import android.content.Context
import com.kakao.sdk.partner.friend.FriendPicker
import com.kakao.sdk.partner.friend.model.RequestMultiPickerParams
import com.kakao.sdk.partner.friend.model.RequestPickerParams
import com.kakao.sdk.partner.friend.model.SelectedUsers

class FriendPickerClient {

    // todo comment
    fun selectMultiple(
        context: Context,
        param: RequestMultiPickerParams,
        callback: (selectedUsers: SelectedUsers?, error: Throwable?) -> Unit
    ) {
        FriendPicker().startActivity(context, param, callback)
    }

    fun selectSingle(
        context: Context,
        param: RequestPickerParams,
        callback: (selectedUsers: SelectedUsers?, error: Throwable?) -> Unit
    ) {
        FriendPicker(isSingle = true).startActivity(context, param, callback)
    }

    fun selectMultiplePopup(
        context: Context,
        param: RequestMultiPickerParams,
        callback: (selectedUsers: SelectedUsers?, error: Throwable?) -> Unit
    ) {
        FriendPicker(isPopup = true).startActivity(context, param, callback)
    }

    fun selectSinglePopup(
        context: Context,
        param: RequestPickerParams,
        callback: (selectedUsers: SelectedUsers?, error: Throwable?) -> Unit
    ) {
        FriendPicker(isSingle = true, isPopup = true).startActivity(context, param, callback)
    }

    companion object {
        @JvmStatic
        val instance by lazy { FriendPickerClient() }
    }
}